Package org.eclipse.cdt.core.dom.ast.cpp

# Interface ICPPASTEnumerationSpecifier

All Superinterfaces:
  `IASTAttributeOwner`, `IASTDeclSpecifier`, `IASTEnumerationSpecifier`, `IASTNameOwner`, `IASTNode`, `ICPPASTDeclSpecifier`

public interface ICPPASTEnumerationSpecifier extends IASTEnumerationSpecifier, ICPPASTDeclSpecifier
`enum struct : unsigned int {...}`

Since:
  5.2
Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Nested Class Summary

Nested Classes
Modifier and Type
Interface
Description
`static enum`
`ICPPASTEnumerationSpecifier.ScopeStyle`

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTEnumerationSpecifier

`IASTEnumerationSpecifier.IASTEnumerator`

## Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final ASTNodeProperty`
`BASE_TYPE`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTAttributeOwner

`ATTRIBUTE, ATTRIBUTE_SPECIFIER`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTDeclSpecifier

`ALIGNMENT_SPECIFIER, sc_auto, sc_extern, sc_mutable, sc_register, sc_static, sc_typedef, sc_unspecified`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTEnumerationSpecifier

`ENUMERATION_NAME, ENUMERATOR`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNameOwner

`r_declaration, r_definition, r_reference, r_unclear`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

## Method Summary

Modifier and Type
Method
Description
`ICPPASTEnumerationSpecifier`
`copy()`
Returns a mutable copy of the tree rooted at this node.
`ICPPASTEnumerationSpecifier`
`copy(IASTNode.CopyStyle style)`
Returns a mutable copy of the tree rooted at this node.
`ICPPASTDeclSpecifier`
`getBaseType()`
Returns the base type for this enum or `null` if it was not specified.
`ICPPScope`
`getScope()`
Returns the scope containing the enumerators of this enumeration, or `null` if the specifier is opaque.
`ICPPASTEnumerationSpecifier.ScopeStyle`
`getScopeStyle()`
`boolean`
`isOpaque()`
An opaque specifier does not have a body.
`boolean`
`isScoped()`
An enum is scoped if it uses the enumeration head `enum class` or `enum struct`.
`void`
`setBaseType(ICPPASTDeclSpecifier baseType)`
Not allowed on frozen ast.
`void`
`setIsOpaque(boolean isOpaque)`
Not allowed on frozen AST.
`void`
`setIsScoped(boolean isScoped)`
Deprecated.
Use setScopeToken instead If `isScoped == true` is passed, the `ScopeToken.CLASS` scope token is assumed.
`void`
`setScopeStyle(ICPPASTEnumerationSpecifier.ScopeStyle scopeStyle)`
Not allowed on frozen AST.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTAttributeOwner

`addAttribute, addAttributeSpecifier, getAttributes, getAttributeSpecifiers`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTDeclSpecifier

`getAlignmentSpecifiers, getStorageClass, isConst, isInline, isRestrict, isVolatile, setAlignmentSpecifiers, setConst, setInline, setRestrict, setStorageClass, setVolatile`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTEnumerationSpecifier

`addEnumerator, getEnumerators, getName, setName`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNameOwner

`getRoleForName`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.cpp.ICPPASTDeclSpecifier

`isConstexpr, isExplicit, isFriend, isThreadLocal, isVirtual, setConstexpr, setExplicit, setFriend, setThreadLocal, setVirtual`

## Field Details

### BASE_TYPE

static final ASTNodeProperty BASE_TYPE

## Method Details

### copy

ICPPASTEnumerationSpecifier copy()
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTDeclSpecifier`
Specified by:
  `copy` in interface `IASTEnumerationSpecifier`
Specified by:
  `copy` in interface `IASTNode`
Specified by:
  `copy` in interface `ICPPASTDeclSpecifier`

### copy

ICPPASTEnumerationSpecifier copy(IASTNode.CopyStyle style)
Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTDeclSpecifier`
Specified by:
  `copy` in interface `IASTEnumerationSpecifier`
Specified by:
  `copy` in interface `IASTNode`
Specified by:
  `copy` in interface `ICPPASTDeclSpecifier`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.
Since:
  5.3

### setIsScoped

@Deprecated void setIsScoped(boolean isScoped)
Deprecated.
Use setScopeToken instead If `isScoped == true` is passed, the `ScopeToken.CLASS` scope token is assumed.
Not allowed on frozen AST.

### setScopeStyle

void setScopeStyle(ICPPASTEnumerationSpecifier.ScopeStyle scopeStyle)
Not allowed on frozen AST.

Since:
  6.6

### getScopeStyle

ICPPASTEnumerationSpecifier.ScopeStyle getScopeStyle()

Since:
  6.6

### isScoped

boolean isScoped()
An enum is scoped if it uses the enumeration head `enum class` or `enum struct`.

### setIsOpaque

void setIsOpaque(boolean isOpaque)
Not allowed on frozen AST.

### isOpaque

boolean isOpaque()
An opaque specifier does not have a body.

### setBaseType

void setBaseType(ICPPASTDeclSpecifier baseType)
Not allowed on frozen ast.

### getBaseType

ICPPASTDeclSpecifier getBaseType()
Returns the base type for this enum or `null` if it was not specified.

### getScope

ICPPScope getScope()
Returns the scope containing the enumerators of this enumeration, or `null` if the specifier is opaque.